<?php

namespace FiloBlu\RuleDayFromBirthday\Api\Data;

use FiloBlu\Core\Framework\Model\RepositoryItem;

/**
 * Interface CustomCouponInterface
 * @package FiloBlu\RuleDayFromBirthday\Api
 */
interface CustomCouponInterface extends RepositoryItem
{

    /** @var string */
    const ROW_ID = 'entity_id';
    const ENTITY_ID = 'entity_id';
    const RULE_ID = 'rule_id';
    const EXPIRATION_DAYS = 'expiration_days';
    const TYPE = 'type';
    const PREFIX = 'prefix';
    const SUFFIX = 'suffix';
    const LENGTH = 'length';
    const FORMAT = 'format';
    const DASH = 'dash';

    /** @var string  */
    const BIRTHDAY_COUPON_TYPE = 'birthday_coupon';
    const DEFAULT_FORMAT = 'alphanum';

    /**
     * @return int|null
     */
    public function getEntityId(): ?int;

    /**
     * @param int $id
     * @return self
     */
    public function setEntityId(int $id): self;

    /**
     * @return int|null
     */
    public function getRuleId(): ?int;

    /**
     * @param int $ruleId
     * @return self
     */
    public function setRuleId(int $ruleId): self;

    /**
     * @return int|null
     */
    public function getExpirationDays(): ?int;

    /**
     * @param int $expirationDays
     * @return self
     */
    public function setExpirationDays(int $expirationDays): self;

    /**
     * @return string|null
     */
    public function getType(): ?string;

    /**
     * @param string $type
     * @return self
     */
    public function setType(string $type): self;

    /**
     * @return string|null
     */
    public function getPrefix(): ?string;

    /**
     * @param string $prefix
     * @return self
     */
    public function setPrefix(string $prefix): self;

    /**
     * @return string|null
     */
    public function getSuffix(): ?string;

    /**
     * @param string $suffix
     * @return self
     */
    public function setSuffix(string $suffix): self;

    /**
     * @return int|null
     */
    public function getLength(): ?int;

    /**
     * @param int $length
     * @return self
     */
    public function setLength(int $length): self;

    /**
     * @return string|null
     */
    public function getFormat(): ?string;

    /**
     * @param string $format
     * @return self
     */
    public function setFormat(string $format): self;

    /**
     * @return int|null
     */
    public function getDash(): ?int;

    /**
     * @param int $dash
     * @return self
     */
    public function setDash(int $dash): self;
}
